
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		sButton, pButton;
	id		aRow, aRowR;
	id		anVari;
	id		anWindow;
	id		auShRow;
	id		basc;
	id		baux;
	id		haHa;
	id		histoGram;
	id		keepTop;
	id		ascru,ruleSamples;
	id		wrule;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id 		revRule;
	id		rijnps;

	id		statEnpai;
	id		statEntro;
	id		statLines;
	id		statMode;
	id		statPair;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statIndx;
	id		statLamb;

	id		tiDat;
	id		autoShCell;
	id		valBx;
	id		varWindow;
	id		theShEvolView;
	id		theThEvolView;
	id		evolWindow;
	id		theEvolView;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	id		probWindow;
	id		plaidWindow;
	id		wholePanel;
	
	id		probEI, probEB, probEO;
	id		probGr, probPo;
	id		probComp;
	id		probGens;
	id		probLevel;
	id		probView;
	
	id		menuCopy;
	id		menuPrint;

        id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;
}

- drawEvolu:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- drawEvolu:sender;
- copyEvolu:sender;
- copyShEvol:sender;
- copyThEvol:sender;
- nxasfreq;
- nxmoncar: (int) l;
- printEvolu:sender;
- rijnRanSam:sender;
- setState:sender;
- showCursor:sender;
- showWrule:sender;
- setRule:sender;
- prob:sender;

- probHowMany:sender;
- probSetEI:sender;
- probSetGen:sender;
- probSetBlk:sender;
- drawBlock:sender;
- drawNBlock:sender;
- drawProb:sender;
- drawPlaid:sender;
- drawStat:sender;
- printBlock:sender;
- printNBlock:sender;
- printPlain:sender;
- printProb:sender;
- printPlaid:sender;
- printStat:sender;
- printShEvol:sender;
- printThEvol:sender;
- printTMatrix:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

@interface Object(PlotViewDelegate)
- PlotView:sender providePoints:(NXStream **)stream;
- PlotView:sender pointDidChange:(NXPoint *)aPoint;
@end

/* end LCAUView.h */
