
/* 
 * RulePanel.h -- Interface file for the RulePanel class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface RulePanel:View {

/* Rule Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */

	id		infoPanel;
	id		mainWindow;
	id		menuCopy;
	id		menuPrint;
	id		nowBox;
	id		nowSpesh;
	id		speshPanel;

/* panel control - - - - - - - - - - - - - - - - - - - - - - - - */

	id		arithmRuleBox;
	id		composRuleBox;
	id		equivRuleBox;
	id		specBigBox;
	id		specLilBox;
	id		subsetRuleBox;

/* Main Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */

	id		ascru;
	id		pSliders;
	id		pWindows;
	id		ruleBox;
	id		ruleNumber;
	id		totlRef;
	id		sIncr;
	id		tiDat;
	id		wrule;


	id		S00,S01,S02,S10,S11,S12,S20,S21,S22;

/* ----- cartesian product  ---------------------------------------------*/
	id		prodRuleBox;
	id		prodFact;

/* ----- composite rule  ------------------------------------------------*/
	id		compRuleBox;
	id		compFact;

/* ----- Fredkin's rule  ------------------------------------------------*/
	id		fredknRuleBox;
	id		fredDir;
	id		fredRule;
	id		fredXor;

/* ----- permuted rule  -------------------------------------------------*/
	id		pRu;

	id		gfWindow;
	id		ruleFormula;

/* semitotalistic Window  - - - - - - - - - - - - - - - - - - - */
	id		stRuleNumber;
	id		stWindow;

/* totalistic rules  - - - - - - - - - - - - - - - - - - - - - */

	id		toascru;
	id		toRuleBox;
	id		toRuleNumber;
	id		toWindow;

/* xenophobic Window  - - - - - - - - - - - - - - - - - - - - - */
	id		obBnry;
	id		obPerm;
	id		obTnry;

/* equivalence Window   - - - - - - - - - - - - - - - - - - - - */
	id		eqChoices;
	id		eqFactor;
	id		eqPair;

	id		statEntro;
	id		statIndx;
	id		statLamb;
	id		statState;
	id		statXeno;

/* design Window  - - - - - - - - - - - - - - - - - - - - - - - */
	id		ddWindow;
	id		designPrm;
	id		designRef;
	id		zeZeZe;

/* ----- REC programming -------------------------------------------------*/

	id		browser;
	id		changeLine;
	id		RECLine;
	id		RECPanel;
	id		RECValue;

	id		dataText;


	id		revRule;

}

- setUpWell: well color: (NXColor)aColor tag: (int)aTag; 

- loadSpecialRule:sender;
- loadLowerPanel:sender;

- freeAllRules:sender;
- ranRules:sender;
- ranPRules:sender;
- relatedRule:sender;
- readWRule:sender;
- protectGenRule:sender;
- setAllRules:sender;
- setDemo:sender;
- setRule:sender; 
- showProbability:sender;
- symRule:sender;
- zeroRules:sender; 

- randomLine:sender;
- sCellLine:sender;
- uniformLine:sender;

- decrPerry:sender;
- incrPerry:sender;
- selectPerry:sender;

- prodRule:sender;

- compRule:sender;

- life3N:sender;

- enterGF3Rule:sender; 
- setMCoeff:sender;
- setSCoeff:sender;
- setVCoeff:sender;

- enterSemiRule:sender;
- setSemiState:sender;

/* Totalistic Rule  - - - - - - - - - - - - - - - - - - - - - */
- enterTotalisticRule:sender;
- ranTRule:sender;
- readTRule:sender;
- setTotalisticState:sender;
- setTotRule:sender;
- setTotRules:sender;

- equivalence:sender;
- ranqul:sender;

- randphobic:sender; 
- xenophilic:sender;
- xenophobic:sender;

- clearDesign:sender;
- copyToDesign:sender;
- deZign:sender;
- enterDesign:sender;

- nxasfreq; 

- perMute:sender;
- showDataText:(char *)text;
- symMetr:sender;

@end 

/* end RulePanel.h */ 
